/*
 * $Id: Validator.java 220 2007-07-16 10:32:15Z sugimotokenichi $
 * Copyright (C) 2005 SUGIMOTO Ken-ichi
 * 作成日: 2006/02/17
 */
package feat2.validation;

import java.util.Map;



/**
 * 検証が可能なクラスのインターフェイス。
 * @author SUGIMOTO Ken-ichi
 */
public interface Validator {

    /**
     * 設定ファイルでバリデーションエラーメッセージが指定されなかったときの
     * デフォルトエラーメッセージIDを返す。
     * @return
     */
    public String getDefaultMessageId();

    /**
     * エラーメッセージに適用するキーワードの置換のマップを返す。
     * @return String型のキー、値を格納したマップ。置き換えるキーワードがない場合はnullを返す。
     */
    public Map getKeyrowds();

}
